/*
 * Copyright (C) 2008 Iowa State University 
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _CONFIRMOVERWRITE_H_
#define _CONFIRMOVERWRITE_H_

#if defined(__GNUG__) && !defined(NO_GCC_PRAGMA)
#pragma interface "confirmoverwrite.h"
#endif

/*!
 * Includes
 */

////@begin includes
////@end includes

#include <wx/dialog.h>

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CONFIRMOVERWRITE 10022
#define ID_TEXTCTRL3 10023
#define SYMBOL_CONFIRMOVERWRITE_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxDIALOG_MODAL|wxTAB_TRAVERSAL
#define SYMBOL_CONFIRMOVERWRITE_TITLE _("Confirm Overwrite")
#define SYMBOL_CONFIRMOVERWRITE_IDNAME ID_CONFIRMOVERWRITE
#define SYMBOL_CONFIRMOVERWRITE_SIZE wxSize(480, 240)
#define SYMBOL_CONFIRMOVERWRITE_POSITION wxDefaultPosition
////@end control identifiers


//! Multi-file confirm overwrite dialog
/*!
 * This class provides a mass Confirm overwrite dialog for confirming the
 * overwrite of multiple files simultaneously.
 *
 * \note Most of the code is generated by DialogBlocks, so it may not be very
 * readable.
 */

class ConfirmOverwrite: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( ConfirmOverwrite )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    ConfirmOverwrite();
    ConfirmOverwrite( wxWindow* parent, wxWindowID id = SYMBOL_CONFIRMOVERWRITE_IDNAME, const wxString& caption = SYMBOL_CONFIRMOVERWRITE_TITLE, const wxPoint& pos = SYMBOL_CONFIRMOVERWRITE_POSITION, const wxSize& size = SYMBOL_CONFIRMOVERWRITE_SIZE, long style = SYMBOL_CONFIRMOVERWRITE_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CONFIRMOVERWRITE_IDNAME, const wxString& caption = SYMBOL_CONFIRMOVERWRITE_TITLE, const wxPoint& pos = SYMBOL_CONFIRMOVERWRITE_POSITION, const wxSize& size = SYMBOL_CONFIRMOVERWRITE_SIZE, long style = SYMBOL_CONFIRMOVERWRITE_STYLE );


    /// Destructor
    ~ConfirmOverwrite();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin ConfirmOverwrite event handler declarations

////@end ConfirmOverwrite event handler declarations

////@begin ConfirmOverwrite member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end ConfirmOverwrite member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin ConfirmOverwrite member variables
    wxTextCtrl* mTextBox;
////@end ConfirmOverwrite member variables

	//! Constructor.
    ConfirmOverwrite(wxWindow *parent, wxArrayString &filenames);
};

#endif
    // _CONFIRMOVERWRITE_H_
