/*
 * Copyright (C) 2008 Iowa State University 
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _JOB_OPTIONS_DIALOG_H_
#define _JOB_OPTIONS_DIALOG_H_

#if defined(__GNUG__) && !defined(NO_GCC_PRAGMA)
#pragma interface "job_options_dialog.h"
#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/spinctrl.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxSpinCtrl;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_JOBOPTIONSDIALOG 10013
#define ID_SPINCTRL1 10012
#define SYMBOL_JOBOPTIONSDIALOG_STYLE wxCAPTION|wxSYSTEM_MENU|wxCLOSE_BOX|wxDIALOG_MODAL|wxTAB_TRAVERSAL
#define SYMBOL_JOBOPTIONSDIALOG_TITLE _("Job Options")
#define SYMBOL_JOBOPTIONSDIALOG_IDNAME ID_JOBOPTIONSDIALOG
#define SYMBOL_JOBOPTIONSDIALOG_SIZE wxDefaultSize
#define SYMBOL_JOBOPTIONSDIALOG_POSITION wxDefaultPosition
////@end control identifiers


//! Job options dialog
/*!
 * This class provides the "Job Options" dialog for GamessQ
 *
 * \note Most of the code is generated by DialogBlocks, so it may not be very
 * readable.
 */

class JobOptionsDialog: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( JobOptionsDialog )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    JobOptionsDialog();
    JobOptionsDialog( wxWindow* parent, wxWindowID id = SYMBOL_JOBOPTIONSDIALOG_IDNAME, const wxString& caption = SYMBOL_JOBOPTIONSDIALOG_TITLE, const wxPoint& pos = SYMBOL_JOBOPTIONSDIALOG_POSITION, const wxSize& size = SYMBOL_JOBOPTIONSDIALOG_SIZE, long style = SYMBOL_JOBOPTIONSDIALOG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_JOBOPTIONSDIALOG_IDNAME, const wxString& caption = SYMBOL_JOBOPTIONSDIALOG_TITLE, const wxPoint& pos = SYMBOL_JOBOPTIONSDIALOG_POSITION, const wxSize& size = SYMBOL_JOBOPTIONSDIALOG_SIZE, long style = SYMBOL_JOBOPTIONSDIALOG_STYLE );

    /// Destructor
    ~JobOptionsDialog();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin JobOptionsDialog event handler declarations

////@end JobOptionsDialog event handler declarations

////@begin JobOptionsDialog member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end JobOptionsDialog member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin JobOptionsDialog member variables
    wxSpinCtrl* procsSpinCtrl;
////@end JobOptionsDialog member variables
	
	//! Returns the value of the "Number of Processors" field
	int GetNumProcessors();
};

#endif
    // _JOB_OPTIONS_DIALOG_H_
